/*
 * Created on Apr 14, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package com.ibm.websphere.sbf;

import java.rmi.RemoteException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.SessionBean;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EFactory;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;

import commonj.sdo.DataObject;

/**
 * @author DABERG
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public abstract class AbstractSDOFacade implements SessionBean {
	private javax.ejb.SessionContext mySessionCtx;
	/**
	 * getSessionContext
	 */
	public javax.ejb.SessionContext getSessionContext() {
		return mySessionCtx;
	}
	/**
	 * setSessionContext
	 */
	public void setSessionContext(javax.ejb.SessionContext ctx) {
		mySessionCtx = ctx;
	}
	/* (non-Javadoc)
	 * @see javax.ejb.SessionBean#ejbRemove()
	 */
	public void ejbRemove() throws EJBException, RemoteException {
	}
	/* (non-Javadoc)
	 * @see javax.ejb.SessionBean#ejbActivate()
	 */
	public void ejbActivate() throws EJBException, RemoteException {
	}
	/* (non-Javadoc)
	 * @see javax.ejb.SessionBean#ejbPassivate()
	 */
	public void ejbPassivate() throws EJBException, RemoteException {
	}
	
	protected List transform(DataObject root, EClass metaClass) {
		List objects = getReturnObjects(root);
		if (objects.isEmpty())
			return Collections.EMPTY_LIST;
		//Turn off notifications while we transform to the real SDO objects.
		//This will avoid changes to the ChangeSummary.
		((EObject) root).eSetDeliver(false);
		List result = new ArrayList(objects.size());
		try {
			createSDOs(objects, result, metaClass);
		} finally {
			((EObject) root).eSetDeliver(true);
		}
		return result;
	}
	/**
	 * @param objects
	 * @param result
	 * @param metaClass
	 */
	private void createSDOs(List objects, List result, EClass metaClass) {
		Iterator it = objects.iterator();
		EObject element = null;
		EObject transformObject = null;
		while (it.hasNext()) {
			element = (EObject) it.next();
			transformObject = transformToSDO(element, result, metaClass);
			if (transformObject != null)
				result.add(transformObject);
		}
		
	}
	/**
	 * @param element
	 * @param result
	 * @param metaClass
	 * @return
	 */
	private EObject transformToSDO(EObject element, List result, EClass metaClass) {
		EObject sdo = createNewSDO(metaClass);
		if (sdo != null) {
			populateSDOAttributes(sdo, element);
			//populateSDOReferences(sdo, element);
		}
		transferAdapters(sdo, element);
		replaceInParent(element, sdo);
		return sdo;
	}
	/**
	 * @param element
	 * @param sdo
	 */
	private void replaceInParent(EObject element, EObject sdo) {
		//Next block is used to replace element in the root with the new
		//sdo object.
		EObject parent = element.eContainer();
		EStructuralFeature containingFeature = element.eContainingFeature();
		if (containingFeature.isMany()) {
			List list = (List) parent.eGet(containingFeature);
			int index = list.indexOf(element);
			list.set(index, sdo);
		} else {
			parent.eSet(containingFeature, sdo);
		}
	}
	/**
	 * @param sdo
	 * @param element
	 */
	private void transferAdapters(EObject sdo, EObject element) {
		List adapters = element.eAdapters();
		if (!adapters.isEmpty()) {
			element.eSetDeliver(false);
			Adapter adapter;
			for (int i = 0; i < adapters.size(); i++) {
				adapter = (Adapter) adapters.get(i);
				sdo.eAdapters().add(adapter);
			}
			adapters.clear();
		}
		
	}
	/**
	 * @param metaClass
	 * @return
	 */
	private EObject createNewSDO(EClass metaClass) {
		EFactory factory = metaClass.getEPackage().getEFactoryInstance();
		return factory.create(metaClass);
	}
	/**
	 * @param sdo
	 * @param element
	 */
	private void populateSDOAttributes(EObject sdo, EObject dynamicElement) {
		List attributes = dynamicElement.eClass().getEAllAttributes();
		Iterator it = attributes.iterator();
		EAttribute attribute;
		while (it.hasNext()) {
			attribute = (EAttribute) it.next();
			if (dynamicElement.eIsSet(attribute))
				setSDOAttribute(attribute, sdo, dynamicElement.eGet(attribute));
		}
		
	}
	/**
	 * @param attribute
	 * @param sdo
	 * @param object
	 */
	private void setSDOAttribute(EAttribute attribute, EObject sdo, Object value) {
		EAttribute sdoAttribute = (EAttribute) sdo.eClass().getEStructuralFeature(attribute.getName());
		if (sdoAttribute != null)
			sdo.eSet(sdoAttribute, value);		
	}
	/**
	 * @param root
	 * @return
	 */
	private List getReturnObjects(DataObject root) {
		return ((EObject) root).eContents();
	}
	
	public void ejbCreate() throws CreateException {
	}
}
